/*********************************************
  netpuyo(client)
  network.c --- protocol operating subroutine
  (C) Sep 17, 1997 ROYALPANDA
**********************************************/

#include<stdio.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<netinet/tcp.h>
#include<netdb.h>
#include<sys/errno.h>

#include"protocol.h"
#include"netpuyo.h"

unsigned char Send_buf[128];  /* Хåե */
unsigned char *Send_write;    /* å */

unsigned char Recv_buf[128]; /* Хåե */
int Recv_len;                /* ɤ߹Ĺ */
int Recv_next;               /* ΥåΥեå */
unsigned char *Recv_read;    /* ɤåΥǡΰ */

#define TCP_PROTO 6   /* TCPΥץȥʥС */

/* ƥॳΥ顼 */

static int syserr( char *msg )
{
  fprintf( stderr,"%s: ",Myname );
  perror( msg );
}



/* Хåեɤ߹ */

void fill_buf( void )
{
  int l;

  if( Recv_len == sizeof(Recv_buf) )
    return;

  if( (l = read(Sock,Recv_buf+Recv_len,sizeof(Recv_buf)-Recv_len )) < 0 ){
    syserr("read");
    close( Sock );
    exit(1);
  }

  if( l == 0 ){
    close(Sock);
    exit(0);
  }

  Recv_len += l;
}


/* å1ɤ߹ */

int recv_msg( void )
{
  int l;

  if( Recv_next ){
    if( Recv_len > Recv_next )
      memmove( Recv_buf,Recv_buf+Recv_next,Recv_len - Recv_next );
    Recv_len -= Recv_next;
    Recv_next = 0;
  }

  if( Recv_len == 0 )
    return 0;

  l = Recv_buf[0] - 32;
  if( l > Recv_len )
    return 0;

  Recv_next = l;
  Recv_read = Recv_buf + 2;
  return Recv_buf[1];
}


/*  */

int recv_snum( void )
{
  return (*Recv_read++) - 32;
}


/* ID(ʬʤ0˽) */
int recv_id( void )
{
  int p;

  p = (*Recv_read++) - 32;
  if( My_id )
    p = 1-p;
  return p;
}


/* 礭 */

int recv_lnum( void )
{
  int i;

  i = Recv_read[0] - 32 + (Recv_read[1]-32) * 64;
  Recv_read += 2;
  return i;
}


/* ʸ */

void recv_str( unsigned char *buf, int siz )
{
  int len;

  for( siz--, len = *Recv_read++ - 32 ; siz > 0 && len > 0 ; siz--, len-- )
    *buf++ = *Recv_read++;

  *buf = '\0';
}



/* å */

void send_init( int msg )
{
  Send_buf[1] = msg;
  Send_write = Send_buf+2;
}


/*  */
void send_snum( int i )
{
  *Send_write++ = i+32;
}


/* ID( 0ʬID˽ ) */

void send_id( int p )
{
  if( My_id )
    p = 1-p;
  *Send_write++ = p+32;
}


/* ʸ */

void send_str( unsigned char *str )
{
  unsigned char *sizp;

  sizp = Send_write++;

  while( *str )
    *Send_write++ = *str++;

  *sizp = Send_write - sizp - 1 + 32;
}


/* åºݤ */

void send_msg( void )
{
  int i,l,w;

  l = Send_write - Send_buf;
  Send_buf[0] = l + 32;

  w = 0;
  while( w < l ){
    if( (i = write( Sock,Send_buf+w,l-w )) < 0 ){
      syserr( "write" );
      close( Sock );
      exit(1);
    }
    w += i;
  }
}

/* ץȥСǧޤϥդ롣 */
/* 󤷤1֤ */

static int logon( void )
{
  int msg;

  for(;;){
    while( (msg = recv_msg()) != 0 ){
      if( msg == MSG_QUIT )
	return 0;
    
      if( msg == MSG_VRSN ){
	if( recv_snum() == 1 ){
	  send_init( MSG_LGON );
	  send_msg();
	  return 1;
	}else{
	  send_init( MSG_QUIT );
	  send_msg();
	  return 0;
	}
      }
    }
    fill_buf();
  }
}

  
/* С³ */

int init_network( char *host,int port )
{
  struct hostent *hp;
  struct sockaddr_in sin;

  static int on = 1;
  
  if( (hp = gethostbyname(host)) == NULL ){
    fprintf( stderr,"%s: unknown host: %s\n",Myname,host );
    return -1;
  }

  if( (Sock = socket(AF_INET,SOCK_STREAM,0)) < 0 ){
    syserr( "socket" );
    return -1;
  }

  memset( &sin,0,sizeof(struct sockaddr_in) );
  sin.sin_family = AF_INET;
  sin.sin_port = htons( port );
  memmove( &sin.sin_addr,hp->h_addr,hp->h_length );

  if( connect( Sock,&sin,sizeof(sin)) < 0 ){
    syserr( "connect" );
    return -1;
  }
  if( setsockopt( Sock,TCP_PROTO,TCP_NODELAY,(char*)&on,sizeof(on) ) < 0 ){
    syserr( "setsockopt" );
    return -1;
  }

  Recv_len = 0;
  Recv_next = 0;

  if( logon() )
    return 0;
  else
    return -1;
}

